## saods9 7.2%2Bdfsg

=== saotk/Makefile ===
include ../make.include
include ../make.pkgs

.NOTPARALLEL :

#--------------------------defines

CXXFLAGS = $(CXXOPT) -I../include -I$(X11INCLUDE)

DIRS	= widget frame colorbar panner magnifier vector list fitsy++ util

OBJS	= \
	widget/*.o \
	frame/*.o \
	colorbar/*.o \
	panner/*.o \
	magnifier/*.o \
	vector/*.o \
	list/*.o \
	fitsy++/*.o \
	util/*.o

LIB	= libsaotk.a

#--------------------------build

all	: $(LIB)
install	: all
	cp -f $(LIB) ../lib/.

#--------------------------items

$(LIB)	: $(DIRS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS)

frame : FORCE
	cd frame; $(MAKE)

colorbar: FORCE
	cd colorbar; $(MAKE)

panner	: FORCE
	cd panner; $(MAKE)

magnifier: FORCE
	cd magnifier; $(MAKE)

widget	: FORCE
	cd widget; $(MAKE)

vector	: FORCE
	cd vector; $(MAKE)

list	: FORCE
	cd list; $(MAKE)

fitsy++	: FORCE
	cd fitsy++; $(MAKE)

util	: FORCE
	cd util; $(MAKE)

clean	: FORCE
	cd frame; $(MAKE) clean
	cd colorbar; $(MAKE) clean
	cd panner; $(MAKE) clean
	cd magnifier; $(MAKE) clean
	cd widget; $(MAKE) clean
	cd vector; $(MAKE) clean
	cd list; $(MAKE) clean
	cd fitsy++; $(MAKE) clean
	cd util; $(MAKE) clean

distclean : FORCE
	rm -f *.o *.a *.so
	cd frame; $(MAKE) distclean
	cd colorbar; $(MAKE) distclean
	cd panner; $(MAKE) distclean
	cd magnifier; $(MAKE) distclean
	cd widget; $(MAKE) distclean
	cd vector; $(MAKE) distclean
	cd list; $(MAKE) distclean
	cd fitsy++; $(MAKE) distclean
	cd util; $(MAKE) distclean

parsers	: FORCE
	cd frame; $(MAKE) parsers
	cd colorbar; $(MAKE) parsers
	cd panner; $(MAKE) parsers
	cd magnifier; $(MAKE) parsers
	cd fitsy++; $(MAKE) parsers

FORCE	:

=== saotk/colorbar/Makefile ===
include ../../make.include

CXXFLAGS = $(CXXOPT) \
	-I. -I.. -I../widget -I../vector -I../list -I../util \
	-I../../include -I$(X11INCLUDE)

SS	= \
	cbgrid.C \
	colorbarbase.C \
	colorbar.C \
	colortag.C \
	colorbartrue.C \
	colorbartruecolor.C \
	colorbartruecolor8.C \
	colorbartruecolor16.C \
	colorbartruecolor24.C \
	colorbarrgb.C \
	colorbarrgbtruecolor.C \
	colorbarrgbtruecolor8.C \
	colorbarrgbtruecolor16.C \
	colorbarrgbtruecolor24.C \
	colormap.C \
	lut.C \
	sao.C \
	default.C

ifeq ($(OS),unix)
SSP =	\
	colorbarpseudo.C \
	colorbarpseudocolor.C \
	colorbarpseudocolor8.C
endif

SRC	= $(SS) $(SSP) \
	parser.C \
	lex.C \
	lutparser.C \
	lutlex.C \
	saoparser.C \
	saolex.C

INCLS	= $(wildcard *.h)
OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f TAGS *.o parser.output lutparser.output saoparser.output

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

parsers	: parser lutparser saoparser

parser	: FORCE
	bison -d -p cb -o parser.C parser.Y
	flex -Pcb -olex.C lex.L

lutparser: FORCE
	bison -d -p rgb -o lutparser.C lutparser.Y
	flex -Prgb -olutlex.C lutlex.L

saoparser: FORCE
	bison -d -p li -o saoparser.C saoparser.Y
	flex -Pli -osaolex.C saolex.L

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)
endif

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
    http://hea-www.harvard.edu/RD/ds9/site/Download.html \
    http://hea-www.harvard.edu/.+/source/ds9\.(.*)\.tar\.gz \
    debian \
    debian/repack-dfsg.sh

## saods9 7.2+dfsg

=== Makefile ===
include make.include
include make.pkgs

.NOTPARALLEL :

#--------------------------defines

export root := $(shell pwd)

USER	= joye
#DEST	= bokhara.cfa.harvard.edu
DEST	= bokhara

DIRS	= bin lib include man html share dist

#--------------------------dirs

SRCDIR	= src
DOCDIR	= doc
DS9DIR	= ds9

#--------------------------cache

CACHE = $(root)/myconfig.cache
LOCALCACHE = myconfig.cache

#--------------------------dist

DS9APP=SAOImage\ DS9\ $(DS9VERSION)
XPAAPP=XPA\ $(XPAVERSION)

#--------------------------blt stuff
BLTINCL	= blt.h bltVector.h

BLTWITHOUT = \
	--without-jpegincdir --without-jpeglibdir \
	--without-pngincdir --without-pnglibdir \
	--without-tiffincdir --without-tifflibdir \
	--without-xpmincdir --without-xpmlibdir \
	--without-xrandrincdir --without-xrandrlibdir \
	--without-expatincdir --without-expatlibdir \
	--without-mysqlincdir --without-mysqllibdir

#--------------------------flags
ifeq ($(OS),unix)
  TCLDIRDIR= $(TCLDIR)/unix
  TKDIRDIR= $(TKDIR)/unix

  XFLAGS = --x-includes=$(X11INCLUDE) --x-libraries=$(X11LIB)

  TCLFLAGS = $(XFLAGS) $(EXTTCLFLAGS)
  TKTABLEFLAGS = $(XFLAGS)
  BLTFLAGS = $(XFLAGS) $(BLTWITHOUT)
  TKIMGFLAGS = $(XFLAGS)
  XPAFLAGS = $(XFLAGS)

  SIGNAL= signal
  SIGNALCLEAN= signalclean

  OPTDIR= unix
  OPTDIRCLEAN= unixclean
endif

ifeq ($(OS),windows)
  TCLDIRDIR= $(TCLDIR)/win
  TKDIRDIR= $(TKDIR)/win

  TCLFLAGS = --enable-symbols
  TKTABLEFLAGS = --enable-symbols
  BLTFLAGS = --without-x $(BLTWITHOUT) \
	--without-xftincdir --without-xftlibdir
  TKIMGFLAGS = --enable-symbols
  XPAFLAGS = --without-x
  PREHTMLFLAGS = config_BUILD_TCLSH=tclsh85sg \
	config_TARGET_TCL_SCRIPT_DIR=$(root)/lib/tcl8.5

  SIGNAL=
  SIGNALCLEAN=

  OPTDIR= win
  OPTDIRCLEAN= winclean
endif

ifeq ($(OS),macosx)
  TCLDIRDIR= $(TCLDIR)/unix
  TKDIRDIR= $(TKDIR)/unix

  TCLFLAGS = --enable-aqua
  BLTFLAGS = --x-includes=/usr/X11/include --x-libraries=/usr/X11/lib \
	$(BLTWITHOUT)

# xpa configure will not accept --without-x
  XPAFLAGS = --with-x=disabled --enable-posix_spawn
  PREHTMLFLAGS = config_TARGET_LIBS="-framework CoreFoundation -framework Carbon" \
	config_TARGET_X_INC="-I$(root)/$(TKDIR)/xlib" \
	config_TARGET_X_LIBS=" "

  FUNTOOLSFLAGS = --enable-posix_spawn

  SIGNAL= signal
  SIGNALCLEAN= signalclean

  OPTDIR= macosx
  OPTDIRCLEAN= macosxclean
endif

CVSFILES = admin \
	checkdns \
	tkmpeg \
	COPYING \
	copyright \
	iis \
	make.darwin64x86mountainlion \
	make.darwinx86mountainlion \
	make.darwinmountainlion \
	make.darwin64x86lion \
	make.darwinx86lion \
	make.darwinlion \
	make.darwin64x86snowleopard \
	make.darwinx86snowleopard \
	make.darwinsnowleopard \
	make.darwin64x86leopard \
	make.darwinx86leopard \
	make.darwinppcleopard \
	make.darwinleopard \
	make.darwinx86tiger \
	make.darwinppctiger \
	make.darwintiger \
	make.linux \
	make.linux64 \
	make.macosxsnowleopard \
	make.macosxx86leopard \
	make.macosxppcleopard \
	make.macosxleopard \
	make.macosxx86tiger \
	make.macosxppctiger \
	make.macosxtiger \
	make.solaris \
	make.source \
	make.windows \
	make.pkgs \
	Makefile \
	notes.txt \
	mods \
	README \
	saotk \
	unix \
	win \
	macosx \
	tests \
	doc \
	cmaps \
	template \
	src \
	msgs \
	ds9 \
	util \
	compilers \
	$(ZVFSDIR)/Makefile \
	$(WCSSUBSDIR)/Makefile \
	$(RICEDIR)/Makefile \
	$(HCOMPRESSDIR)/Makefile \
	$(PLIODIR)/Makefile

#	$(BLTDIR)/src/Makefile-macosx.in \
#	$(BLTDIR)/src/bltMacOSX.h \
#	$(BLTDIR)/src/bltMacOSX.c \
#	$(BLTDIR)/src/macosx.c

ZIPOBJS	 = zipfile.o \
	zipup.o \
	fileio.o \
	util.o \
	globals.o \
	crypt.o \
	ttyio.o \
	unix.o \
	crc32.o \
	deflate.o \
	trees.o

#--------------------------build
all	: build

build : dirs \
	tcl tk \
	tktable tkcon xmlrpc blt \
	zlib tclxml tkimg tkmpeg html \
	xpa iis checkdns $(SIGNAL) funtools \
	ast wcssubs \
	rice hcompress plio \
	$(OPTDIR) \
	saotk zip zvfs ds9

doc	: FORCE
	@echo "Making Documentation..."
	cd $(DOCDIR); $(MAKE)

#--------------------------language

language: FORCE
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl da iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl de iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl es iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl fr iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl pt iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl cs iso8859-2
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl ja euc-jp
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl zh big5

#--------------------------items

ds9	: scrub
	@echo "Making DS9..."
	cd $(DS9DIR); $(MAKE)

ifeq ($(OS),macosx)
ds9app	: ds9
	cd $(DS9DIR); $(MAKE) ds9app

ds9dmg	: FORCE
	rm -rf dist/$(DS9APP)
	rm -rf dist/$(DS9APP).dmg
	mkdir dist/$(DS9APP)
	ln -s /Applications dist/$(DS9APP)/.
	cp -r ds9/macosx/README dist/$(DS9APP)/.
	cp -rp bin/SAOImage\ DS9.app dist/$(DS9APP)/.
	hdiutil create -srcfolder dist/$(DS9APP) dist/$(DS9APP) 

endif

ifeq ($(OS),windows)
ds9app	: ds9
	cd $(DS9DIR); $(MAKE) ds9app

ds9winzip : FORCE
	$(RM) -f dist/$(DS9APP)\ Install.*
	/cygdrive/c/Program\ Files\ \(x86\)/WinZip/wzzip -p -r dist/$(DS9APP)\ Install.zip bin/ds9app
#	/cygdrive/c/Program\ Files\ \(x86\)/WinZip\ Self-Extractor/WINZIPSE.EXE  dist/$(DS9APP)\ Install.zip -setup -i ds9/win/ds9.ico -le -runasuser -t ds9/win/message.txt -a ds9/win/about.txt -c cscript install.vbs 
	/cygdrive/c/Program\ Files\ \(x86\)/WinZip\ Self-Extractor/WINZIPSE.EXE  dist/$(DS9APP)\ Install.zip -d C:\\ds9 -i ds9/win/ds9.ico -le -overwrite -runasuser -c cscript install.vbs

xpawinzip : FORCE
	$(RM) -f dist/$(XPAAPP)\ Install.*
	/cygdrive/c/Program\ Files\ \(x86\)/WinZip/wzzip dist/$(XPAAPP)\ Install.zip bin/xpa* bin/cygwin1.dll
	/cygdrive/c/Program\ Files\ \(x86\)/WinZip\ Self-Extractor/WINZIPSE.EXE  dist/$(XPAAPP)\ Install.zip -d C:\\ds9 -le -overwrite -runasuser
endif

debug	: FORCE
	@echo "Making DS9..."
	cd $(DS9DIR); $(MAKE) debug

dirs	: FORCE
	@echo "Installing Directories..."
	@for d in $(DIRS); do if [ ! -d $$d ]; then mkdir $$d; fi done

tcl	: FORCE
	@echo "Installing Tcl..."
	cd $(TCLDIRDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) $(TCLFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(TCLDIRDIR); $(MAKE) -j $(JOBS); $(MAKE) install

tk	: FORCE
	@echo "Installing Tk..."
	cd $(TKDIRDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) $(TCLFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(TKDIRDIR); $(MAKE) -j $(JOBS); $(MAKE) install
	$(RM) -r lib/$(TKVER)/demos

tktable	: FORCE
	@echo "Installing TkTable..."
	cd $(TKTABLEDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) $(TKTABLEFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(TKTABLEDIR); $(MAKE) -j $(JOBS) ; $(MAKE) install

tkcon	: FORCE
	@echo "Installing TkCon..."
	$(RM) -r lib/$(TKCONVER)
	mkdir lib/$(TKCONVER)
	cp $(TKCONDIR)/*.tcl lib/$(TKCONVER)

xmlrpc	: FORCE
	@echo "Installing XMLRPC..."
	$(RM) -r lib/$(XMLRPCVER)
	mkdir lib/$(XMLRPCVER)
	cp $(XMLRPCDIR)/xmlrpc.tcl lib/$(XMLRPCVER)

blt	: FORCE
	@echo "Installing BLT..."
	cd $(BLTDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-tcl=$(root)/$(TCLDIR) --with-tk=$(root)/$(TKDIR) $(BLTFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(BLTDIR)/src; $(MAKE) -j $(JOBS) build_static
	cp $(BLTDIR)/src/*.a lib/.
	cd $(BLTDIR)/src; cp $(BLTINCL) ../../include/.

zlib  : FORCE
	@echo "Installing zlib..."
	cd $(ZLIBDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --static
	cd $(ZLIBDIR); $(MAKE) -j $(JOBS) install

tclxml	: FORCE
	@echo "Installing TCLXML..."
	cd $(TCLXMLDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --disable-shared --disable-threads --with-xml-static=1 $(TCLXMLFLAGS) --cache-file=$(CACHE)
	cd $(TCLXMLDIR); $(MAKE) -j $(JOBS) ; $(MAKE) install

tkimg	: libtiff
	@echo "Installing TKIMG..."
	cd $(TKIMGDIR); CC='$(CC)' CFLAGS='$(OPTS) -DPNG_NO_WRITE_gAMA' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-tcl=$(root)/$(TCLDIRDIR) --with-tk=$(root)/$(TKDIRDIR) $(TKIMGFLAGS) --disable-shared --disable-threads --cache-file=$(LOCALCACHE)
	cd $(TKIMGDIR); $(MAKE) -j $(JOBS) all; $(MAKE) install

libtiff	: FORCE
	@echo "Installing LIBTIFF..."
	cd $(TKIMGDIR)/compat/libtiff; CC='$(CC)' CFLAGS='$(OPTS)' CXX='$(CC)' CXXFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --disable-shared --cache-file=$(LOCALCACHE)
	cd $(TKIMGDIR)/compat/libtiff; $(MAKE) -j $(JOBS) ; $(MAKE) install

tkmpeg	: FORCE
	@echo "Installing TKMPEG..."
	cd $(TKMPEGDIR); $(MAKE) -j $(JOBS)
	cd $(TKMPEGDIR); $(MAKE) install

html	: FORCE
	@echo "Installing HTMLWIDGET..."
	cd $(HTMLDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' $(PREHTMLFLAGS) $(root)/htmlwidget/configure --prefix $(root) --with-tcl=$(root)/$(TCLDIR) --with-tk=$(root)/$(TKDIR) $(XFLAGS) --enable-shared=no --cache-file=$(CACHE)
	cd $(HTMLDIR); $(MAKE) headers libtkhtml.a
	cp $(HTMLDIR)/libtkhtml.a lib/.

xpa	: FORCE
	@echo "Installing XPA..."
	cd $(XPADIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-tcl=$(root)/$(TCLDIRDIR) $(XPAFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(XPADIR); $(MAKE) -j $(JOBS); $(MAKE) install
	cd bin; strip xpa*

iis	: FORCE
	@echo "Installing IIS..."
	cd $(IISDIR); $(MAKE) -j $(JOBS) install

checkdns: FORCE
	@echo "Installing CheckDNS..."
	cd $(CHECKDNSDIR); $(MAKE) -j $(JOBS) install

signal: FORCE
	@echo "Installing Signal..."
	cd $(SIGNALDIR); $(MAKE) -j $(JOBS) install

funtools: FORCE
	@echo "Installing Funtools..."
	cd $(FUNTOOLSDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-zlib=../../lib/libz.a --with-wcslib=../lib/libwcs.a --enable-mainlib $(FUNTOOLSFLAGS)
	cd $(FUNTOOLSDIR); $(MAKE) lib
	cp $(FUNTOOLSDIR)/libfuntools.a lib/.

ast	: FORCE
	@echo "Installing AST..."
	cd $(ASTDIR); \
	touch aclocal.m4; sleep 1; \
	touch Makefile.in; sleep 1; \
	touch configure; \
	./configure --enable-shared=no --prefix=$(root) $(ASTFLAGS) CC='$(CC)' CFLAGS='$(OPTS) -I.'; \
	$(MAKE) -j $(JOBS) ast.h install-libLTLIBRARIES install-nodist_includeHEADERS install-includeHEADERS

wcssubs	: FORCE
	@echo "Installing WCSSUBS..."
	cd $(WCSSUBSDIR); $(MAKE) -j $(JOBS) install

rice	: FORCE
	@echo "Installing RICE..."
	cd $(RICEDIR); $(MAKE) -j $(JOBS) install

hcompress: FORCE
	@echo "Installing HCOMPRESS..."
	cd $(HCOMPRESSDIR); $(MAKE) -j $(JOBS) install

plio: FORCE
	@echo "Installing PLIO..."
	cd $(PLIODIR); $(MAKE) -j $(JOBS) install

ifdef OPTDIR
$(OPTDIR) : FORCE
	@echo "Installing $(OPTDIR)..."
	cd $(OPTDIR); $(MAKE) -j $(JOBS) install
endif

saotk	: FORCE
	@echo "Installing SAOTK..."
	cd $(SAOTKDIR); $(MAKE) -j $(JOBS) install

zip	: FORCE
	@echo "Installing ZIP..."
	cd $(ZIPDIR); PREFIX=$(root) $(MAKE) -j $(JOBS) CC='$(CC)' CFLAGS='$(OPTS) -I. -DUNIX' LFLAGS1='$(OPTS)' -f unix/Makefile generic
	cd $(ZIPDIR); PREFIX=$(root) $(MAKE) -j $(JOBS) CC='$(CC)' CFLAGS='$(OPTS) -I. -DUNIX' LFLAGS1='$(OPTS)' -f unix/Makefile install
	cd $(ZIPDIR); $(RM) libzip.a
	cd $(ZIPDIR); $(AR) -cr libzip.a $(ZIPOBJS)
	cp $(ZIPDIR)/libzip.a lib/.

zvfs	: FORCE
	@echo "Installing ZVFS..."
	cd $(ZVFSDIR); $(MAKE)
	cd $(ZVFSDIR); $(MAKE) install

#--------------------------clean

scrub : FORCE
	find . -name "*[~#]" -exec rm {} \;
ifeq ($(OS),windows)
	find . -name "*stackdump*" -exec rm {} \;
endif

distclean : filesclean \
	tclclean tkclean \
	tktableclean bltclean \
	zlibclean tclxmlclean tkimgclean tkmpegclean htmlclean \
	xpaclean iisclean checkdnsclean $(SIGNALCLEAN) funtoolsclean \
	astclean wcssubsclean \
	riceclean hcompressclean plioclean \
	$(OPTDIRCLEAN) \
	saotkclean zipclean zvfsclean ds9clean srcclean \
	dirsclean 

filesclean: FORCE
	find . -name "myconfig.cache" -exec rm {} \;
	$(RM) core *~ *#

dirsclean: FORCE
	@for d in $(DIRS); do rm -rf $$d; done

tclclean : FORCE
	cd $(TCLDIRDIR); $(MAKE) distclean

=== checkdns/Makefile ===
include ../make.include

CFLAGS	= $(CCOPT) -I../include

SRC	= checkdns.c

OBJS	= $(SRC:%.c=%.o)

LIB	= libcheckdns.a

all	: $(LIB)
install	: all
	cp -f $(LIB) ../lib/.

$(LIB)	: $(OBJS) $(COBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS) $(COBJS)

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.a *.so *.o

FORCE	:

ifdef DEPENDS
%.d: %.c
	set -e; $(CC) -MM $(CFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.c=.d)
endif

=== ds9/Makefile ===
include ../make.include
include ../make.pkgs

#--------------------------defines

ZDIR	= zipdir/zvfsmntpt
FFILES	= $(ZDIR)/$(TCLVER) \
	$(ZDIR)/tcl8 \
	$(ZDIR)/$(TKVER) \
	$(ZDIR)/$(BLTVER) \
	$(ZDIR)/$(TCLLIBVER) \
	$(ZDIR)/$(TKCONVER) \
	$(ZDIR)/$(XMLRPCVER) \
	$(ZDIR)/src \
	$(ZDIR)/msgs \
	$(ZDIR)/doc \
	$(ZDIR)/cmaps \
	$(ZDIR)/template

ifdef FILTERCOMPILER
FILES	= $(FFILES) \
	$(ZDIR)/$(FILTERCOMPILER)
else
FILES	= $(FFILES)
endif

# for unix, macosx
MAINDIR = ../$(TKDIR)/unix
MAIN	= tkAppInit

LIBS	= \
	../lib/libsaotk.a \
	../lib/libtkhtml.a \
	../lib/libtkmpeg.a \
	../lib/$(TCLXMLVER)/libTclxml3.2.a \
	../lib/$(TKTABLEVER)/libTktable2.10.a \
	../lib/$(TKIMGVER)/libtkimgpng1.4.a \
	../lib/$(TKIMGVER)/libpngtcl1.4.3.a \
	../lib/$(TKIMGVER)/libtkimgtiff1.4.a \
	../lib/$(TKIMGVER)/libtifftcl3.9.4.a \
	../lib/$(TKIMGVER)/libtkimgjpeg1.4.a \
	../lib/$(TKIMGVER)/libjpegtcl8.2.a \
	../lib/$(TKIMGVER)/libtkimggif1.4.a \
	../lib/$(TKIMGVER)/libtkimgppm1.4.a \
	../lib/$(TKIMGVER)/libtkimgwindow1.4.a \
	../lib/$(TKIMGVER)/libzlibtcl1.2.5.a \
	../lib/$(TKIMGVER)/libtkimg1.4.a \
	../lib/libtiff.a \
	../lib/libfuntools.a \
	../lib/librice.a \
	../lib/libhcomp.a \
	../lib/libplio.a \
	../lib/libast.a \
	../lib/libast_err.a \
	../lib/libast_pal.a \
	../lib/libsaotk.a \
	../lib/libwcs.a \
	../lib/libzvfs.a \
	../lib/libzip.a \
	../lib/libz.a \
	../lib/libxpa.a \
	../lib/libiis.a \
	../lib/libcheckdns.a \
	../lib/libsignal_ext.a \
	../lib/libxxlib.a \
	../lib/libBLTX30.a \
	../lib/libBLTCore30.a \
	../lib/libtk8.5.a \
	../lib/libtcl8.5.a

# if windows, redefine
ifeq ($(OS),windows)
  MAINDIR = ../$(TKDIR)/win
  MAIN	= winMain
  RES	= ds9.res.o

  LIBS	= \
	../lib/libsaotk.a \
	../lib/libtkhtml.a \
	../lib/libtkmpeg.a \
	../lib/$(TCLXMLVER)/Tclxml32.a \
	../lib/$(TKTABLEVER)/Tktable210.a \
	../lib/$(TKIMGVER)/tkimgpng14.a \
	../lib/$(TKIMGVER)/pngtcl143.a \
	../lib/$(TKIMGVER)/tkimgtiff14.a \
	../lib/$(TKIMGVER)/tifftcl394.a \
	../lib/$(TKIMGVER)/tkimgjpeg14.a \
	../lib/$(TKIMGVER)/jpegtcl82.a \
	../lib/$(TKIMGVER)/tkimggif14.a \
	../lib/$(TKIMGVER)/tkimgppm14.a \
	../lib/$(TKIMGVER)/tkimgwindow14.a \
	../lib/$(TKIMGVER)/zlibtcl125.a \
	../lib/$(TKIMGVER)/tkimg14.a \
	../lib/libtiff.a \
	../lib/libfuntools.a \
	../lib/librice.a \
	../lib/libhcomp.a \
	../lib/libplio.a \
	../lib/libast.a \
	../lib/libast_err.a \
	../lib/libast_pal.a \
	../lib/libsaotk.a \
	../lib/libwcs.a \
	../lib/libzvfs.a \
	../lib/libzip.a \
	../lib/libz.a \
	../lib/libxpa.a \
	../lib/libiis.a \
	../lib/libcheckdns.a \
	../lib/libxxlib.a \
	../lib/libBLTX30.a \
	../lib/libBLTCore30.a \
	../lib/libtk85sg.a \
	../lib/libtcl85sg.a
endif

OBJS	= ds9.o $(MAIN).o $(RES)

#--------------------------targets

ifeq ($(OS),unix)
CFLAGS= $(CCOPT) -I. -I../include \
	-I../$(TKDIR)/generic -I../$(TKDIR)/unix \
	-I$(X11INCLUDE)

ifneq (,$(findstring darwin,$(ARCH)))

CXXFLAGS = $(CXXOPT) -I. -I../include -I$(X11INCLUDE) -DZIPFILE

all: ds9

ds9	: ds9Base ds9.zip
	$(RM) $@
	cp ds9Base ds9
	strip ds9
	cp ds9 ../bin/.
	cp ds9.zip ../bin/.
	cd ../bin; $(CODESIGN) -s "SAOImage DS9" ds9

debug	: ds9Base ds9.zip
	$(RM) $@
	cp ds9Base ds9

ds9.zip	: $(FILES)
	cd zipdir; ../../bin/zip -r9 ../ds9.zip *	

else

CXXFLAGS = $(CXXOPT) -I. -I../include -I$(X11INCLUDE)

all: ds9

ds9	: null.zip ds9Base $(FILES)
	$(RM) $@
	cp ds9Base ds9.zip
	strip ds9.zip
	cat null.zip >> ds9.zip
	cd zipdir; ../../bin/zip -rA9 ../ds9.zip *
	mv ds9.zip ds9
	cp ds9 ../bin/.

debug	: null.zip ds9Base $(FILES)
	$(RM) $@
	cp ds9Base ds9.zip
	cat null.zip >> ds9.zip
	cd zipdir; ../../bin/zip -rA9 ../ds9.zip *
	mv ds9.zip ds9
endif

endif

ifeq ($(OS),windows)
CFLAGS= $(CCOPT) -I. -I../include \
	-I../$(TKDIR)/generic -I../$(TKDIR)/win \
	-I$(X11INCLUDE)

CXXFLAGS = $(CXXOPT) -I. -I../include -I$(X11INCLUDE) -DZIPFILE

all: ds9.exe

ds9.exe	: ds9Base.exe ds9.zip ../bin/tcc
	$(RM) $@
	cp ds9Base.exe ds9.exe
	strip ds9.exe
	cp ds9.exe ../bin/.
	cp ds9.zip ../bin/.
	cp /bin/cygwin1.dll ../bin/.
	cp /bin/cygxml2-2.dll ../bin/.
	cp /bin/cygstdc++-6.dll ../bin/.
	cp /bin/cygiconv-2.dll ../bin/.
	cp /bin/cygz.dll ../bin/.
	cp /bin/cyggcc_s-1.dll ../bin/.
	cp /bin/cygjbig-2.dll ../bin/.
	cp /bin/cyglzma-5.dll ../bin/.

debug	: ds9Base.exe ds9.zip ../bin/tcc
	$(RM) $@
	cp ds9Base.exe ds9.exe

ds9app	: ds9.exe
	$(RM) -r ../bin/ds9app
	mkdir ../bin/ds9app
	cp ds9.exe ../bin/ds9app/.
	cp ds9.zip ../bin/ds9app/.
	cp /bin/cygwin1.dll ../bin/ds9app/.
	cp /bin/cygxml2-2.dll ../bin/ds9app/.
	cp /bin/cygstdc++-6.dll ../bin/ds9app/.
	cp /bin/cygiconv-2.dll ../bin/ds9app/.
	cp /bin/cygz.dll ../bin/ds9app/.
	cp /bin/cyggcc_s-1.dll ../bin/ds9app/.
	cp /bin/cygjbig-2.dll ../bin/ds9app/.
	cp /bin/cyglzma-5.dll ../bin/ds9app/.
	cp -rp ../bin/tcc ../bin/ds9app/.
	cp ../ds9/win/install.vbs ../bin/ds9app/.

ds9.zip	: $(FILES)
	cd zipdir; ../../bin/zip -r9 ../ds9.zip *	

endif

ifeq ($(OS),macosx)
CFLAGS= $(CCOPT) -I. -I../include \
	-I../$(TKDIR)/generic -I../$(TKDIR)/macosx \
	-I$(X11INCLUDE)

CXXFLAGS = $(CXXOPT) -I. -I../include -I$(X11INCLUDE) -DZIPFILE

all: ds9

ds9	: ds9Base ds9.zip
	$(RM) $@
	cp ds9Base ds9
	strip ds9
	cp ds9 ../bin/.
	cp ds9.zip ../bin/.

debug	: ds9Base ds9.zip
	$(RM) $@
	cp ds9Base ds9

ds9app	: ds9
	rm -rf ../bin/SAOImage\ DS9.app
	cp -rp macosx/SAOImage\ DS9.app ../bin/.
	cd ../bin/SAOImage\ DS9.app; find -d . -name CVS -exec rm -rf {} \;
	cp -p ../bin/ds9 ../bin/SAOImage\ DS9.app/Contents/MacOS/.
	cp -p ../bin/ds9.zip ../bin/SAOImage\ DS9.app/Contents/MacOS/.
	cd ../bin; $(CODESIGN) -s "SAOImage DS9" SAOImage\ DS9.app

ds9.zip	: $(FILES)
	cd zipdir; ../../bin/zip -r9 ../ds9.zip *	

endif

$(MAIN).o : $(MAIN).c
	$(CC) $(CFLAGS) -DTK_LOCAL_APPINIT=SAOAppInit \
	-DTK_LOCAL_MAIN_HOOK=SAOLocalMainHook -c $(MAIN).c -o $@

$(MAIN).c : $(MAINDIR)/$(MAIN).c
	cp $(MAINDIR)/$(MAIN).c .

null.zip:
	echo . | zip null.zip -
	zip null.zip -d -

zipdir	: 
	mkdir zipdir
	mkdir $(ZDIR)

$(ZDIR)/$(TCLVER) : zipdir ../lib/$(TCLVER)
	$(RM) -r $@
	cp -r ../lib/$(TCLVER) $(ZDIR)/.

$(ZDIR)/tcl8 : zipdir ../lib/tcl8
	$(RM) -r $@
	cp -r ../lib/tcl8 $(ZDIR)/.

$(ZDIR)/$(TKVER) : zipdir ../lib/$(TKVER)
	$(RM) -r $@
	cp -r ../lib/$(TKVER) $(ZDIR)/.
	rm -rf $(ZDIR)/$(TKVER)/images
	rm -rf $(ZDIR)/$(TKVER)/demos

$(ZDIR)/$(BLTVER) : zipdir
	$(RM) -r $@
	mkdir $(ZDIR)/$(BLTVER)
	mkdir $(ZDIR)/$(BLTVER)/afm
	cp ../$(BLTDIR)/library/graph.tcl $(ZDIR)/$(BLTVER)/.
	cp ../$(BLTDIR)/library/bltGraph.pro $(ZDIR)/$(BLTVER)/.
	cp ../$(BLTDIR)/library/tclIndex $(ZDIR)/$(BLTVER)/.
	cp ../$(BLTDIR)/library/afm/*.afm $(ZDIR)/$(BLTVER)/afm/.

$(ZDIR)/$(TCLLIBVER) : zipdir
	$(RM) -r $@
	mkdir $(ZDIR)/$(TCLLIBVER)
	cp -r ../$(TCLLIBDIR)/modules/base64 $(ZDIR)/$(TCLLIBVER)/.
	cp -r ../$(TCLLIBDIR)/modules/ftp $(ZDIR)/$(TCLLIBVER)/.
	cp -r ../$(TCLLIBDIR)/modules/log $(ZDIR)/$(TCLLIBVER)/.
	cp -r ../$(TCLLIBDIR)/modules/textutil $(ZDIR)/$(TCLLIBVER)/.
	cp -r ../$(TCLLIBDIR)/modules/math $(ZDIR)/$(TCLLIBVER)/.

$(ZDIR)/$(TKCONVER) : zipdir ../lib/$(TKCONVER)
	$(RM) -r $@
	cp -r ../lib/$(TKCONVER) $@

$(ZDIR)/$(XMLRPCVER) : zipdir ../lib/$(XMLRPCVER)
	$(RM) -r $@
	cp -r ../lib/$(XMLRPCVER) $@

$(ZDIR)/src : zipdir ../src/*.tcl
	$(RM) -r $@
	cp -r ../src $(ZDIR)/.

$(ZDIR)/msgs : zipdir ../msgs/*
	$(RM) -r $@
	cp -r ../msgs $(ZDIR)/.

$(ZDIR)/doc : zipdir ../doc/* ../doc/ref/* ../doc/user/* ../doc/release/*
	$(RM) -r $@
	cd ..; find doc -name "*.html" | cpio -pdmuv ds9/$(ZDIR)
	cd ..; find doc -name "*.gif" | cpio -pdmuv ds9/$(ZDIR)
	cd ..; find doc -name "*.png" | cpio -pdmuv ds9/$(ZDIR)

$(ZDIR)/cmaps : zipdir ../cmaps/*
	$(RM) -r $@
	cp -r ../cmaps $(ZDIR)/.

$(ZDIR)/template : zipdir ../template/*
	$(RM) -r $@
	cd ..; find template -name "*.tpl" | cpio -pdmuv ds9/$(ZDIR)

ifdef FILTERCOMPILER
$(ZDIR)/$(FILTERCOMPILER) : zipdir ../compilers/$(FILTERCOMPILER)
	$(RM) -r $@
	cp ../compilers/$(FILTERCOMPILER) $(ZDIR)/$(FILTERCOMPILER)
endif

#--------------------------solaris

ifeq ($(ARCH),solaris)
ds9Base	: $(OBJS) $(LIBS)
	$(RM) $@
	rm -f libstdc++.a
	ln -s `$(CXX) ${OPTS} -print-file-name=libstdc++.a` .
	$(CXX) -static-libgcc ${OPTS} \
	-o $@ $(OBJS) $(LIBS) \
	-Wl,-Bstatic -L. -lstdc++ \
	-Wl,-Bdynamic \
	-L$(X11LIB) -lX11 -lXext -lXft -lXrender -lfontconfig -lfreetype \
	-lxml2 \
	-lsocket -lnsl -ldl
	rm -f libstdc++.a
endif

#--------------------------linux

ifneq (,$(findstring linux,$(ARCH)))
ds9Base	: $(OBJS) $(LIBS)
	$(RM) $@
	rm -f libstdc++.a
	ln -s `$(CXX) ${OPTS} -print-file-name=libstdc++.a` .
	$(CXX) ${OPTS} -static-libgcc -Wl,--export-dynamic \
	-o $@ $(OBJS) $(LIBS) \
	-Wl,-Bstatic -L. -lstdc++ \
	-Wl,-Bdynamic \
	-L$(X11LIB) -lX11 -lXext -lXft -lXrender -lXss \
	-lxml2 \
	-ldl -lpthread 
	rm -f libstdc++.a
endif

#--------------------------darwin

ifneq (,$(findstring darwin,$(ARCH)))
ds9Base	: $(OBJS) $(LIBS)
	$(RM) $@
	$(CXX) ${OPTS} \
	-o $@ $(OBJS) $(LIBS) \
	-L$(X11LIB) -lX11 -lXext -lXft -lXrender -lXss -lfontconfig -lfreetype \
	-lxml2 \
	-lstdc++ -liconv
endif

#--------------------------macosx

ifeq ($(OS),macosx)
ds9Base	: $(OBJS) $(LIBS)
	$(RM) $@
	$(CXX) ${OPTS} \
	-o $@ $(OBJS) $(LIBS) \
	-lxml2 \
	-lstdc++ -liconv \
	-sectcreate __TEXT __tk_rsrc ../$(TKDIR)/unix/tk8.5.rsrc \
	-framework CoreFoundation -framework Carbon
endif

#--------------------------windows

ifeq ($(OS),windows)
ds9Base.exe: $(OBJS) $(LIBS)
	$(RM) $@
	$(CXX) ${OPTS} \
	-o $@ $(OBJS) $(LIBS) \
	-lxml2 -ljbig \
	-lws2_32 -limm32 -lcomctl32 -mwindows 

$(RES)	: win/ds9.rc win/ds9.ico
	windres -o $@ --define STATIC_BUILD --include ../$(TKDIR)/generic \
	--include ../$(TCLDIR)/generic --include ../$(TKDIR)/win/rc \
	--include win win/ds9.rc

../bin/tcc: ../compilers/$(TCC)
	$(RM) -r $@
	cd ../bin; unzip ../compilers/$(TCC)
	chmod +x ../bin/tcc/tcc.exe
	touch $@

endif

#--------------------------cleanup

clean	: FORCE
	$(RM) core *~ *# 

ifeq ($(OS),windows)
distclean: FORCE
	$(RM) core *~ *# ds9Base.exe ds9.exe *.zip *.o
	$(RM) -r zipdir bin/tcc
else
distclean: FORCE
	$(RM) core *~ *# ds9Base ds9 *.zip *.o
	$(RM) -r zipdir
endif

FORCE	:

=== iis/Makefile ===
include ../make.include

CXXFLAGS = $(CXXOPT) -I../include
CFLAGS = $(CCOPT) -I../include

SRC	= iistcl.C xim.C
CSRC	= iis.c util.c

OBJS	= $(SRC:%.C=%.o)
COBJS	= $(CSRC:%.c=%.o)

LIB	= libiis.a
SHARED	= libiis.so

all	: $(LIB)
install	: all
	cp -f $(LIB) ../lib/.

$(LIB)	: $(OBJS) $(COBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS) $(COBJS)

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.a *.so *.o

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)

%.d: %.c
	set -e; $(CC) -MM $(CFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(CSRC:.c=.d)
endif

=== macosx/Makefile ===
include ../make.include
include ../make.pkgs

CXXFLAGS = $(CXXOPT) -I../include -I../saotk/vector \
	-I../$(TKDIR)/generic -I../$(TKDIR)/win \
	-I$(X11INCLUDE)

SRC	= tkmacosx.C \
	macosxlib.C \
	xxlib.C \

OBJS	= $(SRC:%.C=%.o)

INCLS	= macosxlib.h \
	xxlib.h

LIB	= libxxlib.a

all	: $(LIB)
install	: all
	cp $(INCLS) ../include/.
	cp $(LIB) ../lib/.

$(LIB)	: $(OBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS)

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.o *.so *.a

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)
endif

=== plio/Makefile ===
include ../make.include

CFLAGS	= $(CCOPT) -I.

SRC	= pliocomp.c

OBJS	= $(SRC:%.c=%.o)
LIB	= libplio.a

$(LIB)	: $(OBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS)

install	: $(LIB)
	cp $(LIB) ../lib/.

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.o *.a *.so

FORCE	:

=== src/Makefile ===
include ../make.include

SCRIPTS = \
	2mass.tcl \
	3d.tcl \
	array.tcl \
	analysis.tcl \
	analysisparam.tcl \
	annulus.tcl \
	ar.tcl \
	backup.tcl \
	bin.tcl \
	box.tcl \
	boxannulus.tcl \
	bpanda.tcl \
	buttons.tcl \
	cat.tcl \
	catcds.tcl \
	catcdssrch.tcl \
	catcdssrchdialog.tcl \
	catcmd.tcl \
	catcxc.tcl \
	catdialog.tcl \
	catflt.tcl \
	catmatch.tcl \
	catned.tcl \
	catopt.tcl \
	catplot.tcl \
	catreg.tcl \
	catsdss.tcl \
	catsimbad.tcl \
	catskybot.tcl \
	catsym.tcl \
	cattsv.tcl \
	catvot.tcl \
	centroid.tcl \
	circle.tcl \
	colorbar.tcl \
	comm.tcl \
	command.tcl \
	compass.tcl \
	composite.tcl \
	contour.tcl \
	convert.tcl \
	coord.tcl \
	cpanda.tcl \
	crop.tcl \
	crosshair.tcl \
	cube.tcl \
	debug.tcl \
	dialog.tcl \
	ellipse.tcl \
	ellipseannulus.tcl \
	epanda.tcl \
	error.tcl \
	eso.tcl \
	examine.tcl \
	export.tcl \
	external.tcl \
	file.tcl \
	fits.tcl \
	first.tcl \
	frame.tcl \
	graph.tcl \
	grid.tcl \
	group.tcl \
	header.tcl \
	help.tcl \
	http.tcl \
	hv.tcl \
	hvform.tcl \
	hvsup.tcl \
	iis.tcl \
	imexam.tcl \
	imgsvr.tcl \
	import.tcl \
	info.tcl \
	layout.tcl \
	line.tcl \
	load.tcl \
	magnifier.tcl \
	marker.tcl \
	markeranalysispanda.tcl \
	markeranalysisplot2d.tcl \
	markeranalysisplot3d.tcl \
	markeranalysisradial.tcl \
	markeranalysisstats.tcl \
	markerbase.tcl \
	markerbaseannulus.tcl \
	markerbaseannulusrect.tcl \
	markerbasecenter.tcl \
	markerbaseline.tcl \
	markerbasepanda.tcl \
	markerbasepandarect.tcl \
	markerdialog.tcl \
	mask.tcl \
	manalysis.tcl \
	mbin.tcl \
	mcolor.tcl \
	mecube.tcl \
	medit.tcl \
	menu.tcl \
	mfile.tcl \
	mframe.tcl \
	mhelp.tcl \
	mosaicimage.tcl \
	mosaicimageiraf.tcl \
	mosaicimagewcs.tcl \
	mosaicimagewfpc2.tcl \
	mosaic.tcl \
	mosaiciraf.tcl \
	mosaicwcs.tcl \
	movie.tcl \
	mregion.tcl \
	mscale.tcl \
	multiframe.tcl \
	mview.tcl \
	mwcs.tcl \
	mzoom.tcl \
	nameres.tcl \
	nrrd.tcl \
	nsvr.tcl \
	nvss.tcl \
	pagesetup.tcl \
	panner.tcl \
	panzoom.tcl \
	pixel.tcl \
	photo.tcl \
	plot.tcl \
	plotbar.tcl \
	plotdialog.tcl \
	plotelement.tcl \
	plotline.tcl \
	plotprint.tcl \
	plotprocess.tcl \
	plotscatter.tcl \
	point.tcl \
	polygon.tcl \
	prefs.tcl \
	prefsdialog.tcl \
	print.tcl \
	projection.tcl \
	open.tcl \
	rgb.tcl \
	rgbarray.tcl \
	rgbcube.tcl \
	rgbimage.tcl \
	ruler.tcl \
	samp.tcl \
	sao.tcl \
	save.tcl \
	saveimage.tcl \
	scale.tcl \
	sfits.tcl \
	shm.tcl \
	skyview.tcl \
	slider.tcl \
	smosaic.tcl \
	smosaiciraf.tcl \
	smosaicwcs.tcl \
	smooth.tcl \
	source.tcl \
	srgbcube.tcl \
	starbase.tcl \
	stdfbox.tcl \
	stsci.tcl \
	template.tcl \
	text.tcl \
	tkfbox.tcl \
	url.tcl \
	util.tcl \
	var.tcl \
	vector.tcl \
	vo.tcl \
	wcs.tcl \
	xmfbox.tcl \
	xpa.tcl

INDEX	= pkgIndex.tcl

index	: $(SCRIPTS)
	echo "pkg_mkIndex . $(SCRIPTS)" | ../bin/tclsh8.4

msgs	: FORCE
	grep 'msgcat::mc' $(SCRIPTS) | cut -d[ -f2 | sed -e 's/::mc/::mcset AAA /' -e 's/]/ ""/' | sort | uniq > ../msgs/tmpl.tcl

clean	: FORCE
	$(RM) core *~ *# 

distclean : clean
	$(RM) $(INDEX)

FORCE	:

=== tkmpeg/Makefile ===
include ../make.include

# we must compile non-optimized (MacOSX)

CXXFLAGS = $(CXXNOPT) -I../include -I$(X11INCLUDE)
CFLAGS	= $(CCNOPT) -I.

SRC	= tkmpeg.C
CSRC	= ezmpeg.c

OBJS	= $(SRC:%.C=%.o)
COBJS	= $(CSRC:%.c=%.o)

LIB	= libtkmpeg.a

all	: $(LIB)
install	: all
	cp -f $(LIB) ../lib/.

$(LIB)	: $(OBJS) $(COBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS) $(COBJS)

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.a *.so *.o

FORCE	:

=== unix/Makefile ===
include ../make.include
include ../make.pkgs

CXXFLAGS = $(CXXOPT) -I../include  -I../saotk/vector -I../saotk/widget -I$(X11INCLUDE)

SRC	= rotstr.C

OBJS	= $(SRC:%.C=%.o)

INCLS	= rotstr.h

LIB	= libxxlib.a

all	: $(LIB)
install	: all
	cp $(INCLS) ../include/.
	cp $(LIB) ../lib/.

$(LIB)	: $(OBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS)

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.o *.so *.a

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)
endif

=== saotk/fitsy++/Makefile ===
include ../../make.include
include ../../make.pkgs

CXXFLAGS = $(CXXOPT) -I. -I.. -I../vector -I../util \
	-I../../include -I$(X11INCLUDE) \
	-I../../$(FUNTOOLSDIR)/filter -I../../$(FUNTOOLSDIR)/fitsy \
	-I../../$(FUNTOOLSDIR)/util

SS	= \
	alloc.C \
	allocgz.C \
	analysis.C \
	card.C \
	channel.C \
	column.C \
	compress.C \
	gzip.C \
	gzraw.C \
	iis.C \
	hcompress.C \
	hdu.C \
	head.C \
	hist.C \
	hpx.C \
	file.C \
	map.C \
	mapincr.C \
	mmap.C \
	mmapincr.C \
	nrrd.C \
	nrrdgzip.C \
	outchannel.C \
	outfile.C \
	outfits.C \
	outsocket.C \
	photo.C \
	plio.C \
	rice.C \
	savefits.C \
	share.C \
	sshare.C \
	smap.C \
	smmap.C \
	socket.C \
	socketgz.C \
	strm.C \
	var.C

SRC	= $(SS) \
	parser.C \
	lex.C \
	nrrdparser.C \
	nrrdlex.C

INCLS	= $(wildcard *.h)
OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f TAGS *.o parser.output nrrdparser.output

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

parsers	: parser nrrdparser

parser	: FORCE
	bison -d -p ff -o parser.C parser.Y
	flex -Pff -olex.C lex.L

nrrdparser : FORCE
	bison -d -p nrrd -o nrrdparser.C nrrdparser.Y
	flex -Pnrrd -onrrdlex.C nrrdlex.L

shmload	: shmload.C
	$(RM) $@
	$(CXX) $(CXXOPT) -o $@ $<
	cp $@ ../../bin/.

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SS:.C=.d)
endif

=== saotk/frame/Makefile ===
include ../../make.include
include ../../make.pkgs

CXXFLAGS = $(CXXOPT) -w \
	-I. -I.. -I../widget -I../vector -I../list -I../fitsy++ -I../util \
	-I../../include -I$(X11INCLUDE) \
	-I../../$(FUNTOOLSDIR)/util \
	-I/usr/include/libxml2 \
	-I../../$(ASTDIR)

SS	= \
	annulus.C \
	base.C \
	basecommand.C \
	basebox.C \
	baseellipse.C \
	baseline.C \
	basemarker.C \
	basepanda.C \
	box.C \
	boxannulus.C \
	bpanda.C \
	callback.C \
	circle.C \
	colorscale.C \
	colorscalergb.C \
	colorscaletrue8.C \
	colorscaletrue16.C \
	colorscaletrue24.C \
	colorscaletrue32.C \
	compass.C \
	composite.C \
	context.C \
	contour.C \
	coord.C \
	cpanda.C \
	ellipse.C \
	ellipseannulus.C \
	epanda.C \
	fitsanalysis.C \
	fitsbin.C \
	fitscompress.C \
	fitsdata.C \
	fitshealpix.C \
	fitsimage.C \
	fitsmask.C \
	fitsmap.C \
	fitsnrrd.C \
	frame.C \
	frame3d.C \
	framebase.C \
	frame3dbase.C \
	framergb.C \
	framergbtruecolor.C \
	framergbtruecolor8.C \
	framergbtruecolor16.C \
	framergbtruecolor24.C \
	frametrue.C \
	frame3dtrue.C \
	frametruecolor.C \
	frame3dtruecolor.C \
	frametruecolor8.C \
	frametruecolor16.C \
	frametruecolor24.C \
	frame3dtruecolor8.C \
	frame3dtruecolor16.C \
	frame3dtruecolor24.C \
	frblt.C \
	frcommand.C \
	fr3dcommand.C \
	frload.C \
	frmap.C \
	fr3dmap.C \
	frmarker.C \
	frmarkerxml.C \
	frsave.C \
	frscale.C \
	fvcontour.C \
	grid.C \
	grid2d.C \
	grid25d.C \
	grid3d.C \
	inversescale.C \
	line.C \
	marker.C \
	point.C \
	polygon.C \
	projection.C \
	ruler.C \
	tag.C \
	text.C \
	vect.C

ifeq ($(OS),unix)
SSP =	\
	colorscalepseudo8.C \
	framepseudo.C \
	framepseudocolor.C \
	framepseudocolor8.C
endif

SRC	= $(SS) $(SSP) \
	ciaoparser.C \
	ciaolex.C \
	ds9parser.C \
	ds9lex.C \
	parser.C \
	lex.C \
	prosparser.C \
	proslex.C \
	saoparser.C \
	saolex.C \
	tngparser.C \
	tnglex.C \
	xyparser.C \
	xylex.C

INCLS	= $(wildcard *.h)
OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f TAGS *.o parser.output ds9parser.output ciaoparser.output prosparser.output tngparser.output saoparser.output xyparser.output

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

parsers	: ciaoparser ds9parser parser prosparser saoparser tngparser xyparser

ciaoparser : FORCE
	bison -d -p ciao -o ciaoparser.C ciaoparser.Y
	flex -Pciao -ociaolex.C ciaolex.L

ds9parser : FORCE
	bison -d -p mk -o ds9parser.C ds9parser.Y
	flex -Pmk -ods9lex.C ds9lex.L

parser : FORCE
	bison -d -p fr -o parser.C parser.Y
	flex -Pfr -olex.C lex.L

prosparser : FORCE
	bison -d -p pros -o prosparser.C prosparser.Y
	flex -Ppros -oproslex.C proslex.L

saoparser : FORCE
	bison -d -p sao -o saoparser.C saoparser.Y
	flex -Psao -osaolex.C saolex.L

tngparser : FORCE
	bison -d -p tng -o tngparser.C tngparser.Y
	flex -Ptng -otnglex.C tnglex.L

xyparser : FORCE
	bison -d -p xy -o xyparser.C xyparser.Y
	flex -Pxy -oxylex.C xylex.L

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SS:.C=.d)
endif

=== saotk/list/Makefile ===
include ../../make.include

CXXFLAGS = $(CXXOPT) \
	-I. -I../vector -I../frame -I../colorbar -I../../include -I$(X11INCLUDE)

SRC	= list.C

INCLS	= $(wildcard *.h)
OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f TAGS *.o $(LIB)

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)
endif

=== debian/changelog ===
saods9 (7.2+dfsg-4) unstable; urgency=low

  [Sergei Golovan]
  * Use tcl8.5-dev and tk8.5-dev build dependencies instead of tcl-dev and
    tk-dev because of FTBFS in case of upgrading tcl-dev and tk-dev to 8.6.
    Closes: #726758

 -- Ole Streicher <debian@liska.ath.cx>  Fri, 18 Oct 2013 21:48:14 +0400

saods9 (7.2+dfsg-3) unstable; urgency=low

  * Re-create htmlwidget/configure. Fixes FTBS on MIPS.

 -- Ole Streicher <debian@liska.ath.cx>  Sat, 28 Sep 2013 15:29:28 +0200

saods9 (7.2+dfsg-2) unstable; urgency=low

  * Create make.linux on clean, closes: #724082

 -- Ole Streicher <debian@liska.ath.cx>  Thu, 26 Sep 2013 18:26:11 +0200

saods9 (7.2+dfsg-1) unstable; urgency=low

  * Change distribution to unstable

 -- Ole Streicher <debian@liska.ath.cx>  Wed, 24 Apr 2013 18:39:50 +0200

saods9 (7.2+dfsg-1~exp1) experimental; urgency=low

  * New upstream version
  * Copyright changed to GPL-3+
  * Push standards-version t 3.9.4 (no change needed)

 -- Ole Streicher <debian@liska.ath.cx>  Tue, 16 Apr 2013 11:28:43 +0200

saods9 (7.1+dfsg-1~exp3) experimental; urgency=low

  * Remove explicite link to tcl8.5 in htmlwidget; fixes FTBS on alpha
    and sh4

 -- Ole Streicher <debian@liska.ath.cx>  Tue, 22 Jan 2013 11:10:00 +0100

=== debian/control ===
Source: saods9
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <debian@liska.ath.cx>
Build-Depends: autotools-dev,
               debhelper (>= 9),
	       dh-autoreconf,
               html2text,
               cpio,
               libfuntools-dev,
               libstarlink-ast-dev (>= 7.0.4),
               libtk-img-dev,
               libwcstools-dev,
               libxml2-dev,
               libxrandr-dev,
               libxt-dev,
               perl,
               tcl8.5-dev,
               tk8.5-dev,
               zlib1g-dev
Standards-Version: 3.9.4
Homepage: http://hea-www.harvard.edu/RD/ds9/site/Home.html
Vcs-Git: git://anonscm.debian.org/debian-science/packages/saods9.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/saods9.git

Package: saods9
Architecture: any
Depends: libtk-img,
         saods9-data (= ${source:Version}),
         saods9-blt,
         tcl-signal,
         tcl-xpa,
         tcllib,
         tclxml,
         tk-table (>= 2.9),
         tkcon,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: saods9-doc
Suggests: xpa-tools, python-pyds9
Description: Image display tool for astronomy
 SAOImage DS9 is an astronomical imaging and data visualization
 application. DS9 supports FITS images and binary tables, multiple frame
 buffers, region manipulation, and many scale algorithms and colormaps. It
 provides for easy communication with external analysis tasks and is highly
 configurable and extensible via XPA and SAMP.
 .
 All versions and platforms support a consistent set of GUI and
 functional capabilities. 
 .
 DS9 supports advanced features such as 2-D, 3-D and RGB frame buffers, mosaic
 images, tiling, blinking, geometric markers, colormap manipulation, scaling,
 arbitrary zoom, cropping, rotation, pan, and a variety of coordinate
 systems.
 .
 The GUI for DS9 is user configurable. GUI elements such as the coordinate
 display, panner, magnifier, horizontal and vertical graphs, button bar, and
 color bar can be configured via menus or the command line.

Package: saods9-blt
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: BLT subpackage for saods9
 DS9 is an application for astronomical imaging and data
 visualization.
 .
 This package contains an updated and patched version of BLT for the use 
 in saods9.

Package: saods9-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Image display tool for astronomy (help files/documentation)
 SAOImage DS9 is an astronomical imaging and data visualization
 application. DS9 supports FITS images and binary tables, multiple frame
 buffers, region manipulation, and many scale algorithms and colormaps. It
 provides for easy communication with external analysis tasks and is highly
 configurable and extensible via XPA and SAMP.
 .
 This package contains the documentation and help pages.

Package: saods9-data
Architecture: all
Depends: ${misc:Depends}
Description: Image display tool for astronomy (shared data)
 SAOImage DS9 is an astronomical imaging and data visualization
 application. DS9 supports FITS images and binary tables, multiple frame
 buffers, region manipulation, and many scale algorithms and colormaps. It
 provides for easy communication with external analysis tasks and is highly
 configurable and extensible via XPA and SAMP.
 .
 This package contains the architecture independent files.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

BUILDPARTS:=dirs checkdns tkmpeg html iis rice hcompress plio xmlrpc unix blt saotk ds9

get-orig-source:
	sh ./debian/repack-dfsg.sh

%:
	dh $@ --with autoreconf

make.include:
	ln -sf make.linux make.include

override_dh_autoreconf:
	(cd htmlwidget; autoreconf -i -f)

override_dh_auto_build: make.include
	dh_auto_build -- $(BUILDPARTS)
	chmod ugo-x ds9/zipdir/zvfsmntpt/src/*.tcl
	perl -w debian/generate-man > ds9/ds9.1

override_dh_installchangelogs:
	dh_installchangelogs doc/release/r7.0.html

override_dh_auto_clean: make.include
	dh_auto_clean
